"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "getEventsInRange", {
    enumerable: true,
    get: ()=>getEventsInRange
});
let prevTurn = -1;
const getEventsInRange = (turns, loop, loopStart, loopEnd, currentTime, playbackStartTime, quantumDurationTime)=>{
    let startTime;
    let endTime;
    let offsetTime = 0;
    let loopDuration = 0;
    const results = [];
    let needTurn = 0;
    let turn = 0;
    if (loop) {
        loopDuration = loopEnd - loopStart;
        offsetTime = currentTime - loopStart;
        turn = offsetTime / loopDuration | 0;
        needTurn = turn + 2;
        if (turn !== prevTurn) {
            prevTurn = turn;
        }
        startTime = offsetTime;
        if (startTime < 0) {
            return {
                needTurn,
                results
            };
        }
        endTime = startTime + quantumDurationTime;
    } else {
        startTime = currentTime - playbackStartTime;
        endTime = startTime + quantumDurationTime;
    }
    for(let t = 0; t <= 1; t++){
        const events = turns.get(turn + t);
        const offset = loopDuration * (turn + t) + 0.00001;
        if (events) for (const event of events){
            const eventTime = event.midiEvent.receivedTime * 0.001 // ms to seconds
             + offset;
            if (eventTime > endTime) break;
            if (eventTime > startTime) {
                let receivedTime = eventTime;
                receivedTime *= 1000;
                results.push([
                    receivedTime,
                    event
                ]);
            }
        }
    }
    return {
        needTurn,
        results
    };
};

//# sourceMappingURL=util.js.map